layout_with_graphopt {igraph} | R Documentation

## The graphopt layout algorithm

### Description

A force-directed layout algorithm, that scales relatively well to large graphs.

### Usage

    layout_with_graphopt(graph, start = NULL, niter = 500, charge = 0.001,
      mass = 30, spring.length = 0, spring.constant = 1,
      max.sa.movement = 5)

    with_graphopt(...)

### Arguments

`graph` | The input graph.
`start` | If given, then it should be a matrix with two columns and one line for each vertex. This matrix will be used as starting positions for the algorithm. If not given, then a random starting matrix is used.
`niter` | Integer scalar, the number of iterations to perform. Should be a couple of hundred in general. If you have a large graph then you might want to only do a few iterations and then check the result. If it is not good enough you can feed it in again in the `start` argument. The default value is 500.
`charge` | The charge of the vertices, used to calculate electric repulsion. The default is 0.001.
`mass` | The mass of the vertices, used for the spring forces. The default is 30.
`spring.length` | The length of the springs, an integer number. The default value is zero.
`spring.constant` | The spring constant, the default value is one.
`max.sa.movement` | Real constant, it gives the maximum amount of movement allowed in a single step along a single axis. The default value is 5.
`...` | Passed to `layout_with_graphopt`.

### Details

`layout_with_graphopt` is a port of the graphopt layout algorithm by Michael Schmuhl. graphopt version 0.4.1 was rewritten in C and the support for layers was removed (might be added later) and a code was a bit reorganized to avoid some unneccessary steps is the node charge (see below) is zero.

graphopt uses physical analogies for defining attracting and repelling forces among the vertices and then the physical system is simulated until it reaches an equilibrium. (There is no simulated annealing or anything like that, so a stable fixed point is not guaranteed.)

See also http://www.schmuhl.org/graphopt/ for the original graphopt.

### Value

A numeric matrix with two columns, and a row for each vertex.

### Author(s)

Michael Schmuhl for the original graphopt code, rewritten and wrapped by Gabor Csardi csardi.gabor@gmail.com.

### See Also

Other graph layouts: `add_layout_`, `component_wise`, `layout_as_bipartite`, `layout_as_star`, `layout_as_tree`, `layout_in_circle`, `layout_nicely`, `layout_on_grid`, `layout_on_sphere`, `layout_randomly`, `layout_with_dh`, `layout_with_fr`, `layout_with_gem`, `layout_with_kk`, `layout_with_lgl`, `layout_with_mds`, `layout_with_sugiyama`, `layout_`, `merge_coords`, `norm_coords`, `normalize`

[Package igraph version 1.1.2 Index]